library(DBI)
library(RMySQL)

lablog.append <- function(df){
}

lablog.find <- function(out=FALSE){
  md <- MySQL()
  mc <- dbConnect(md)
  .zzz <- try(mysqlInsertId(mc))
  if(class(.zzz)=="try-error"){
    mysqlInsertId <- function(conn){
      return(dbGetQuery(conn,"select last_insert_id()"))
    }
  }
  frame <- NULL
  selectedEntry<<-NULL
  selectedGroup<<-NULL
  gladewidget2<-function(name,tree=XML.db){
    w<-gladeXMLGetWidget(tree,name)
    class(w)<-gtkObjectGetClasses(w,check=F)
    w
  }
  search.db <- function(...){
    qr <- NULL
    if ((z <- sid.w$GetText())!=""){
      qr <- c(qr,paste("SAMPLES.sid like","\'",z,"\'",sep=""))
    }
    if ((z <- composition.w$GetText())!=""){
      qr <- c(qr,paste("SAMPLES.composition like","\'",z,"\'",sep=""))
    }
    if ((z <- type.w$GetText())!=""){
      qr <- c(qr,paste("JOURNAL.type like \'",z,"\'",sep=""))
    }
    if ((z <- name.w$GetText())!=""){
      qr <- c(qr,paste("PARS.parname like \'",z,"\'",sep=""))
    }
   if ((z <- unit.w$GetText())!=""){
      qr <- c(qr,paste("PARS.parunit like \'",z,"\'",sep=""))
    } 
    if ((z <- other.w$GetText())!=""){
      qr <- c(qr,z)
    }
    qr <- paste(qr,collapse=" and ")
    if (qr!=""){
      qr <- paste("and",qr)
    }
    frame <<- dbGetQuery(mc,statement=paste("select SAMPLES.*,JOURNAL.expid,JOURNAL.type,JOURNAL.date,PARS.pargroup,PARS.parid,concat(PARS.parname,'[0] = ',PARVALUES.value,' ',PARS.parunit) from SAMPLES natural left join JOURNAL natural left join PARS natural left join PARVALUES where (PARVALUES.tuple=0 or PARVALUES.tuple is null)",qr,"order by SAMPLES.sample,JOURNAL.expid,PARS.pargroup,PARS.parid"))
    v1<-factor(frame[,1])
    frame[10]<<-ifelse(as.logical(cumsum(c(1,as.integer(v1[1:length(v1)-1]!=v1[2:length(v1)])))%%2),"white","grey90")
    v1<-factor(frame[,4])
    frame[11]<<-ifelse(as.logical(cumsum(c(1,as.integer(v1[1:length(v1)-1]!=v1[2:length(v1)])))%%2),"white","grey90")
    v1<-factor(frame[,7])
    frame[12]<<-ifelse(as.logical(cumsum(c(1,as.integer(v1[1:length(v1)-1]!=v1[2:length(v1)])))%%2),"white","grey90")
    frame[13]<<- ifelse(as.logical(seq(along=frame[,8])%%2),"white","grey90")
    selectedGroup<<-NULL
    selectedEntry<<-NULL
    selectedSample <<- ""
    c.w$Clear()
    for (i in seq(along=frame[,1])){
      j<-c.w$Append()$iter
      for (k in seq(along=frame[i,])){
        c.w$SetValue(j,k-1,frame[i,k])
      }      
    }
  }
  frame.stat <- function(tv) {
    gtkTreePathGetIndices(tv$GetCursor()$path)[1]->r
    selectedGroup<<-frame$pargroup[r+1]
    selectedEntry<<-frame$expid[r+1]
    selectedSample<<-frame$sid[r+1]
    frame.stat <<- dbGetQuery(mc,paste("select concat(parname,'(',parunit,')[',PARS.parid,']'),count(value),min(value),max(value),avg(value),std(value) from PARS natural left join PARVALUES where pargroup=",frame$pargroup[r+1],"group by PARS.parid"))
    stat.w$Clear()
    for (i in seq(along=frame.stat[,1])){
      j<-stat.w$Append()$iter
      for (k in seq(along=frame.stat[i,])){
        stat.w$SetValue(j,k-1,frame.stat[i,k])
      }      
    }
  }
  set.pars <- function(...){
    commit.to.db <- function(df){
      if (is.null(selectedEntry)){
        selectedSample <<- sid.w$GetText()
        dbGetQuery(mc,paste("insert into SAMPLES set sample=null,sid=\'",sid.w$GetText(),"\',composition=\'",composition.w$GetText(),"\'",sep=""))
        mysqlInsertId(mc)->j
        dbGetQuery(mc,paste("insert into JOURNAL set sample=",j,",expid=null,type=\"",type.w$GetText(),"\",date=now()",sep=""))
        selectedEntry <<- mysqlInsertId(mc)
      }
      dbGetQuery(mc,"insert into PARGROUPS set pargroup=null")
      selectedGroup<<-mysqlInsertId(mc)
      for (i in seq(along=df)){
        i1 <- comment(df[[i]])
        i2 <- names(df)[[i]]
        dbGetQuery(mc,paste("insert into PARS set expid=",selectedEntry,",pargroup=",selectedGroup,",parid=null,parname=\'",i2,"\',parunit=\'",i1,"\'",sep=""))
        mysqlInsertId(mc)->j
        vals <- paste(j,seq(along=df[[i]])-1,df[[i]],sep=",",collapse="),(")
        dbGetQuery(mc,paste("insert into PARVALUES values(",vals,")",sep=""))
      }
    }
    e<-RGorace:::wisard.out(grid.get(current.Figure$current.Panel$elements[[current.Figure$current.Panel$.Selected.Element]]$name),commit.to.db,var.names=list(),var.units=list())
  }
  get.frame <- function(...){
    if (is.null(selectedGroup)){
      search.db()

      if (length(unique(frame$pargroup)!=1)){
        return()
      }
      selectedSample<<-frame$sid[1]
      selectedEntry<<-frame$expid[1]
      selectedGroup<<-frame$pargroup[1]
    }
    z <- dbGetQuery(mc,paste("select parid,parname,parunit from PARS where pargroup=",selectedGroup,sep=""))
    print(z)
    g<-NULL
    for (i in 1:dim(z)[1]){
      k<-dbGetQuery(mc,paste("select value from PARVALUES where parid=",z[["parid"]][i],sep=""))
      names(k) <- z[["parname"]][i]
      comment(k) <- z[["parunit"]][i]
      if (is.null(g)){
        g <- k
      } else {
        g<-data.frame(g,k)
      }
    }
    assign(paste(".",selectedSample,sep=""),g,envir=parent.env(environment()))
    on.close()
    RGorace:::wisard.in(g,frame.name=selectedSample)
  }
  on.close <- function(...){
    dbDisconnect(mc)
    window2.w$Destroy()
  }
  if (out){
    get.or.set<-set.pars
  } else {
    get.or.set<-get.frame
   }
  XML.db <- gladeXMLNew(system.file("db.interface.glade",package="RGorace"))
  sapply(c("tv.c","tv.stat","get","sid","composition","type","name","unit","other","window2"),function(x){assign(paste(x,".w",sep=""),gladewidget2(x,XML.db),envir=parent.env(environment()))})  
  h1<-cbind(c("Sample #","  SID  ","Comosition","Exp #", " Type ", "    Date   ","Frame #","Par #","Parname[Unit]=Value[0]","col1","col2","col3","col4"),c("integer","character","character","integer","character","character","integer","integer","character","character","character","character","character"))
  tv.c.w$SetModel(c.w<-gtkListStoreNew(h1[,2]))
  for (i in 1:9){
      col<-12
      if (i%in%1:3){col<-9}
      else if (i%in%4:6){col<-10}
      else if (i%in%7){col<-11}
      tv.c.w$AppendColumn(gtkTreeViewColumnNewWithAttributes(h1[i,1],gtkCellRendererTextNew(),text=i-1,background=col))
 }
  h2<- cbind(c("   Parameter   ","  Length  ","    Min   ","    Max   ", "   Average  ", "    STD   "),c("character","integer","numeric","numeric","numeric","numeric"))
  tv.stat.w$SetModel(stat.w<-gtkListStoreNew(h2[,2]))
  for (i in seq(along=h2[,1])){
      tv.stat.w$AppendColumn(gtkTreeViewColumnNewWithAttributes(h2[i,1],gtkCellRendererTextNew(),text=i-1))
  }
  try(gladeXMLAutoconnect(XML.db,function(handler,obj,signal,...){try(obj$AddCallback(signal,get(handler)))}))
  window2.w$ShowAll()
  return(environment())
}


db.user.menu <- function(fig){
  z1.Action <- function(...){
    fig$fig$set.active()
    l <- lablog.find(FALSE)
  }
  z2.Action <- function(...){
    fig$fig$set.active()
    l <- lablog.find(TRUE)
  }
  z1 <- gtkMenuItem("Download From LabLog")
  z2 <- gtkMenuItem("Upload To LabLog")
  z <- fig$gladewidget("file1_menu1")
  z$Insert(z2,4)
  z$Insert(z1,4)
  z1$AddCallback("activate",z1.Action)
  z2$AddCallback("activate",z2.Action)
}
